type token =
  | QUESTION
  | COLON
  | ACTION_IF
  | ADD_KIT
  | ADD_MUSIC
  | ADD_PROJECTILE
  | ADD_STATE_TRIGGER
  | ADD_TRANS_TRIGGER
  | ADD_STORE_ITEM
  | ALLOW_MISSING
  | ALWAYS
  | AND
  | OR
  | NOT
  | ELSE
  | LPAREN
  | RPAREN
  | APPEND
  | APPENDI
  | APPEND_COL
  | ASK_EVERY_COMPONENT
  | AT_EXIT
  | AT_INTERACTIVE_EXIT
  | AT_INTERACTIVE_UNINSTALL
  | SET_2DA_ENTRY
  | READ_2DA_ENTRY
  | AT_UNINSTALL
  | AUTHOR
  | AUTO_TRA
  | BACKUP
  | BEGIN
  | BUT_ONLY_IF_IT_CHANGES
  | CHAIN2
  | CHAIN3
  | COMPILE
  | COPY
  | GLOB
  | COPY_EXISTING
  | COPY_EXISTING_REGEXP
  | COPY_RANDOM
  | COPY_TRANS
  | DELETE_BYTES
  | DEPRECATED
  | DO
  | END
  | EQUALS
  | EQUALSEQUALS
  | EXIT
  | EXTEND_BOTTOM
  | EXTEND_BOTTOM_REGEXP
  | EXTEND_TOP
  | EXTEND_TOP_REGEXP
  | EXTERN
  | FAIL
  | FILE_CONTAINS
  | FILE_MD5
  | FILE_EXISTS
  | FILE_EXISTS_IN_GAME
  | FILE_SIZE
  | FLAGS
  | FORBID_FILE
  | GOTO
  | GT
  | GTE
  | LT
  | LTE
  | BAND
  | BOR
  | BXOR
  | BLSL
  | BASR
  | BLSR
  | BNOT
  | IF
  | SET
  | IF_EVAL
  | IF_SIZE_IS
  | INSERT_BYTES
  | INTERJECT
  | INTERJECT_COPY_TRANS
  | JOURNAL
  | SOLVED_JOURNAL
  | UNSOLVED_JOURNAL
  | LANGUAGE
  | MENU_STYLE
  | MKDIR
  | PATCH_GAM
  | PLUS
  | MINUS
  | TIMES
  | DIVIDE
  | PRINT
  | RANDOM_SEED
  | READ_ASCII
  | READ_BYTE
  | READ_LONG
  | READ_SHORT
  | REPLACE
  | REPLACE_ACTION_TEXT
  | REPLACE_ACTION_TEXT_PROCESS
  | REPLACE_BCS_BLOCK
  | REPLACE_BCS_BLOCK_REGEXP
  | APPLY_BCS_PATCH
  | APPLY_BCS_PATCH_OR_COPY
  | REPLACE_SAY
  | REPLACE_STATE_TRIGGER
  | REPLACE_TEXTUALLY
  | REPLACE_TRIGGER_TEXT
  | REPLACE_TRIGGER_TEXT_REGEXP
  | REPLY
  | REQUIRE_FILE
  | REQUIRE_COMPONENT
  | FORBID_COMPONENT
  | SAY
  | SET_WEIGHT
  | STRING of (string)
  | STRING_SET
  | THEN
  | UNINSTALL
  | UNLESS
  | USING
  | WEIGHT
  | WRITE_ASCII
  | WRITE_EVALUATED_ASCII
  | WRITE_BYTE
  | WRITE_LONG
  | WRITE_SHORT
  | WHILE
  | EOF
  | SOUND of (string)
  | STRING_REF of (int)
  | TRANS_REF of (int)
  | FORCED_STRING_REF of (int)

val d_file :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Dc.action list
val tra_file :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> (int * Dlg.tlk_string) list
val tp_file :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Tp.tp_file
val log_file :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> (string * int * int * (string option)) list
